#include <fstream>
#include <iostream>
#include <sstream>
#include <string>

#include <cstdlib>

void parse_line(std::string const &src, std::string &fname, std::string &coords) {
  std::istringstream parser(src);

  parser >> fname;
  std::getline(parser, coords);
}

std::string assemble_morph_command(std::string const &fname_from,
                                   std::string const &coords_from,
                                   std::string const &fname_to,
                                   std::string const &coords_to,
                                   int strip)
{
  std::ostringstream fmt;

  fmt << "./shapemorph2 -b white -c1 " << coords_from << " -c2 " << coords_to << " ../" << fname_from << " ../" << fname_to << " strip-" << strip << ".miff";
  return fmt.str();
}

std::string assemble_expand_command(int strip) {
  std::ostringstream fmt;

  fmt << "convert -monochrome strip-" << strip << ".miff strip-" << strip << ".png";

  return fmt.str();
}

void morph(std::string const &line_from,
           std::string const &line_to,
           int strip) {
  std::string fname_from;
  std::string fname_to;
  std::string coords_from;
  std::string coords_to;

  parse_line(line_from, fname_from, coords_from);
  parse_line(line_to  , fname_to  , coords_to  );

  std::system(assemble_morph_command(fname_from, coords_from, fname_to, coords_to, strip).c_str());
  std::system(assemble_expand_command(strip).c_str());
}

int main() {
  std::ifstream in_coord("coordinates.txt");
  std::string line_from;
  std::string line_to;
  int strip = 0;

  std::getline(in_coord, line_from);

  while(std::getline(in_coord, line_to)) {
    morph(line_from, line_to, strip);

    line_from = line_to;
    ++strip;
  }
}
