#include "parts.hh"

#include "cube.hh"
#include "point3d.hh"

#include <flipdot/flipdot.hh>

#include <boost/thread.hpp>

#include <cmath>
#include <string>

void part_cube(flipdot::display &disp) {
  cube  c(20,  7,  0, 20);
  point3d p(30, 17, 10);

  cube c2(25, 12,  5, 10);

  boost::posix_time::milliseconds interval(80);

  auto now = boost::get_system_time();
  auto next = now + interval;

  bool     wireframe = false;
  unsigned wireframe_timer = 100;

  std::string message_left  = "     CREDITS     Code:  Wintermute SvOlli     Grafix:  Deft Veto Wintermute SvOlli     Music:  Skyrunner ";
  std::string message_right = "                     Your message here.  Call XayaX Advertising Ltd. under 1|800|SELLOUTS                ";

  std::size_t msgpos_left  = 0;
  std::size_t msgpos_right = 0;
  int fontpos = 0;

  for(std::size_t ctr = 0; ctr < 1000; ++ctr) {
    flipdot::image img;

    c.rotate(p, 0.05, 0.03, 0.02);
    c2.rotate(p, -0.02, -0.03, -0.05);
    if(wireframe) {
      c.render(img);
      c2.render(img);
    } else {
      c.render(img, true, true);
    }

    for(int i = 0; i < 6; ++i) {
      flipdot::render_char(img,  2, fontpos + i * flipdot::FONT_HEIGHT, message_left [(msgpos_left  + i) % message_left .size()]);
      flipdot::render_char(img, 53, fontpos + i * flipdot::FONT_HEIGHT, message_right[(msgpos_right + i) % message_right.size()]);
    }

    --fontpos;
    if(fontpos == -8) {
      fontpos = 0;
      msgpos_left  = (msgpos_left  + 1) % message_left .size();
      msgpos_right = (msgpos_right + 1) % message_right.size();

      if(msgpos_left == 0) {
        break;
      }
    }

    if(wireframe_timer == 0) {
      wireframe_timer = 100;
      wireframe = !wireframe;
    } else {
      --wireframe_timer;
    }

    img.flush(disp);

    now = next;
    next = now + interval;

    boost::this_thread::sleep(next);
  }
}
