#ifndef INCLUDED_POINT_HH
#define INCLUDED_POINT_HH

#include <flipdot/image.hh>

class point3d {
public:
  point3d(double x = 0.0, double y = 0.0, double z = 0.0) : x_(x), y_(y), z_(z) { }

  inline double x() const { return x_; }
  inline double y() const { return y_; }
  inline double z() const { return z_; }

  inline void x(double new_x) { x_ = new_x; }
  inline void y(double new_y) { y_ = new_y; }
  inline void z(double new_z) { z_ = new_z; }

private:
  double x_;
  double y_;
  double z_;
};

void draw_line(flipdot::image &img, point3d const &pt1, point3d const &pt2);
void draw_point(flipdot::image &img, point3d const &pt);

void rotate(point3d &pt, point3d const &pivot, double anglex, double angley, double anglez);
void rotate(point3d &pt, point3d const &pivot, point3d const &direction);

void move(point3d &pt, double dx, double dy, double dz);
void move(point3d &pt, point3d const &dir);

point3d interpolate(point3d const &pt1, point3d const &pt2, double dist);

#endif
