#ifndef INCLUDED_FLIPDOT_HH
#define INCLUDED_FLIPDOT_HH

#include <cstddef>
#include <cstdint>
#include <string>
#include <vector>

namespace flipdot {
  enum {
    MODULE_ROWS  = 16,
    MODULE_COLS  = 20,
    MODULE_GAP   =  4,

    DISPLAY_WIDTH = 3,
    DISPLAY_COLS = DISPLAY_WIDTH * MODULE_COLS
  };

  typedef std::vector<std::uint16_t> framebuffer;

  class display {
  public:
    display(std::size_t module_count = 6);
    void flush(framebuffer const &fb);

    inline framebuffer empty_framebuffer() const { return framebuffer(module_count_ * MODULE_COLS, 0x0000); }

  private:
    std::size_t module_count_;
    std::size_t display_height_;
    std::string linedelim_;
  };
}

#endif /* FLIPDOT_H */
