#ifndef INCLUDED_ICONVERTER_HH
#define INCLUDED_ICONVERTER_HH

#include <iconv.h>
#include <stdexcept>
#include <string>

struct iconv_error : public std::logic_error {
  iconv_error(std::string const &message);
};

struct iconv_open_error : public iconv_error {
  iconv_open_error(std::string const &tocode, std::string const &fromcode);
};

class iconverter {
public:
  iconverter(std::string const &tocode,
             std::string const &fromcode,
             double expansion_hint = 1.2);
  ~iconverter();

  std::string operator()(std::string const &text);

private:
  iconv_t converter_;
  double  expansion_hint_;
};

#endif
