#ifndef INCLUDED_FLIPDOT_IMAGE_HH
#define INCLUDED_FLIPDOT_IMAGE_HH

#include "display.hh"

#include <cstddef>
#include <cstdint>

namespace flipdot {
  enum {
    COLOR_WHITE,
    COLOR_BLACK,

    BLT_MIRRORED = 1
  };

  struct sprite {
    int width;
    int height;
    std::uint8_t const *data;
  };

  class image {
  public:
    image(int gap_width      = 3,
          int height_modules = 2,
          int width_modules  = 3);

    inline void flush(flipdot::display &disp) const { disp.flush(fb_); }

    void pixel_black(int x, int y);
    void pixel_white(int x, int y);
    void pixel_set  (int x, int y, int val);

    void clear();
    void blt(int x, int y, sprite const &spr, std::uint32_t flags = 0);

    int width () const { return width_ ; }
    int height() const { return height_; }

    image &operator^=(image const &other);

  private:
    flipdot::framebuffer fb_;
    int width_;
    int height_;
    int module_height_;
    int stripe_count_;
  };
}

#endif
